/******************************************************************************
**         File: $RCSfile$
**
**  Description:
**
**      Created: $Date$
**
**      Changes: $Revision$
**   $Log$ 
**
** Distribution: $Name$ 
******************************************************************************/   
/*-----------------------------------------------------------------------------
-- SYSTEM INCLUDE FILE DECLARATIONS
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
-- PRIVATE INCLUDE FILE DECLARATIONS
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
-- DEFINITIONS
-----------------------------------------------------------------------------*/
#define APPNAME "kalax"
#define APPVERS "0.1"
#define APPCAPT "Game"


// Game-Geom-Specific
#define FIELD_WIDTH         640
#define FIELD_HEIGHT        480
#define LEFT_FIELD_OFFSET    20
#define RIGHT_FIELD_OFFSET   20
#define TOP_FIELD_OFFSET     30
#define BOTTOM_FIELD_OFFSET  40


#define ENEMY_L_BOUND      LEFT_FIELD_OFFSET
#define ENEMY_R_BOUND      FIELD_WIDTH - RIGHT_FIELD_OFFSET
#define ENEMY_T_BOUND      TOP_FIELD_OFFSET
#define ENEMY_B_BOUND      FIELD_HEIGHT - BOTTOM_FIELD_OFFSET

#define ENEMY_SHOOT_L_BOUND  ENEMY_L_BOUND   
#define ENEMY_SHOOT_R_BOUND  ENEMY_R_BOUND  
#define ENEMY_SHOOT_T_BOUND  ENEMY_T_BOUND   
#define ENEMY_SHOOT_B_BOUND  ENEMY_B_BOUND    


#define PLAYER_L_BOUND      LEFT_FIELD_OFFSET
#define PLAYER_R_BOUND      FIELD_WIDTH - RIGHT_FIELD_OFFSET
#define PLAYER_T_BOUND      FIELD_HEIGHT - BOTTOM_FIELD_OFFSET - 100
#define PLAYER_B_BOUND      FIELD_HEIGHT - BOTTOM_FIELD_OFFSET


#define PLAYER_SHOOT_L_BOUND  ENEMY_L_BOUND   
#define PLAYER_SHOOT_R_BOUND  ENEMY_R_BOUND  
#define PLAYER_SHOOT_T_BOUND  ENEMY_T_BOUND   
#define PLAYER_SHOOT_B_BOUND  ENEMY_B_BOUND    

                                               
// Enemy-Ships
#define ENEMY_1_SPRITE_DATA    "/enemy_1.%d.ppm"
#define ENEMY_1_SPRITE_MASK    "/enemy_1.%d.pbm"
#define ENEMY_1_SPRITE_COUNT   36

#define ENEMY_2_SPRITE_DATA    "/enemy_2.%d.ppm"
#define ENEMY_2_SPRITE_MASK    "/enemy_2.%d.pbm"
#define ENEMY_2_SPRITE_COUNT   36

#define ENEMY_3_SPRITE_DATA    "/enemy_3.%d.ppm"
#define ENEMY_3_SPRITE_MASK    "/enemy_3.%d.pbm"
#define ENEMY_3_SPRITE_COUNT   36

#define ENEMY_4_SPRITE_DATA    "/enemy_4.%d.ppm"
#define ENEMY_4_SPRITE_MASK    "/enemy_4.%d.pbm"
#define ENEMY_4_SPRITE_COUNT   36

// Destroy Animation
#define DESTROY_SPRITE_DATA    "/destr_%d.ppm"
#define DESTROY_SPRITE_MASK    "/destr_%d.pbm"
#define DESTROY_SPRITE_COUNT   9
                                               
// Player-Shot
#define PSHOOT_SPRITE_DATA    "/player_shot_%d.ppm"
#define PSHOOT_SPRITE_MASK    "/player_shot_%d.pbm"

#define PSHOOT_SPRITE_COUNT   1

// Enemy-shot
#define ESHOOT_SPRITE_DATA    "/enemy_shot_%d.ppm"
#define ESHOOT_SPRITE_MASK    "/enemy_shot_%d.pbm"
#define ESHOOT_SPRITE_COUNT   1

// Soundfilenames
#define ESHOOT_SOUNDNAME			"eshoot.wav"
#define ESHOOT_SOUND				0
#define PSHOOT_SOUNDNAME			"rshoot.wav"
#define RSHOOT_SOUND				1
#define EDESTROY_SOUNDNAME		"edestroy.wav"
#define EDESTROY_SOUND			2
#define PDESTROY_SOUNDNAME		"rdestroy.wav"
#define RDESTROY_SOUND			3


/*-----------------------------------------------------------------------------
-- TYPE DEFINITIONS
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
-- GLOBAL VARIABLES
-----------------------------------------------------------------------------*/






