/*
**         File: $RCSfile$
**
**  Description:
**
**      Created: $Date$
**
**      Changes: $Revision$
**   $Log$ 
**
** Distribution: $Name$ 
******************************************************************************/   
#ifndef ENEMY_H
#define ENEMY_H

/*-----------------------------------------------------------------------------
-- SYSTEM INCLUDE FILE DECLARATIONS
-----------------------------------------------------------------------------*/
#include <qpntarry.h> 
#include "QwSpriteField.h" 

/*-----------------------------------------------------------------------------
-- PRIVATE INCLUDE FILE DECLARATIONS
-----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
-- DEFINITIONS
-----------------------------------------------------------------------------*/
#define RTTI_ENEMY	1001

/*-----------------------------------------------------------------------------
-- TYPE DEFINITIONS
-----------------------------------------------------------------------------*/
class flightPlan
{
  public:
    flightPlan();
    ~flightPlan();

                      // rel pos p
    int addPlanEntry( QPoint p, int frame );     // fill in right order
    int getPlanEntry( int planEntry, int &x, int &y, int &frame );
         
  private:
    QPointArray flightCoords;  // size()
    QPointArray frameNumbers;  // bad solution, but it works
    
};


class EnemyType: public QwSpritePixmapSequence
{
  public:
    EnemyType( const char* datafilenamepattern, const char* maskfilenamepattern, int framecount=1)
            :QwSpritePixmapSequence( datafilenamepattern, maskfilenamepattern, framecount )
    {    
    }
    ~EnemyType()
    {
    }
};

class Enemy: public QwMobileSprite     // public QObject
{
//  Q_OBJECT;

  public:
    Enemy( QPoint startPos, EnemyType *enemyType, flightPlan *defaultFlightPlan );
    
    ~Enemy();
    
    void setVelocity( int velocity );
    
    void specialFlightPlan( flightPlan *flightThis );
    void nextStep();

    virtual int rtti() const
    {   return RTTI_ENEMY; }


    bool enemyFlys;
//  public slots:

//  signals:

  private:
    flightPlan *defaultPlan;           // Normal flightPlan
    QPoint      defaultPos;            // Enemyposition in normal filghtplan
    int         defaultPlanEntry;
    
    flightPlan *specFlightPlan;        // Special flightPlan
    int         flightPlanEntry;
                                       
    int         enemySpeed;            // velocity multiplier
  
  protected:

};

#endif // ENEMY_H




